#include "trackball.h"

using namespace Ogre;
using namespace std;

//************************************************************
// Implementation of Trackball
//************************************************************
Trackball::Trackball(CEGUI::OgreCEGUIRenderer* r,CEGUI::System* s)
  : mGUIRenderer(r),
    mGUISystem(s)
{  
}
void
Trackball::mousePressed(MouseEvent *e)
{
  CEGUI::MouseCursor::getSingleton().hide();
}
void
Trackball::mouseReleased(MouseEvent *e)
{
  CEGUI::MouseCursor::getSingleton().show();
}
void
Trackball::mouseMoved(MouseEvent *e)
{
  CEGUI::System::getSingleton().injectMouseMove(e->getRelX()*mGUIRenderer->getWidth(), 
                                                e->getRelY()*mGUIRenderer->getHeight());
}
void
Trackball::mouseDragged(MouseEvent *e)
{
  CEGUI::System::getSingleton().injectMouseMove(e->getRelX() * mGUIRenderer->getWidth(), 
                                                e->getRelY() * mGUIRenderer->getHeight());
}
// Broken functions that we must however derive because they
// are pure virtuals.
void
Trackball::mouseClicked(MouseEvent*)
{
}
void
Trackball::mouseEntered(MouseEvent*)
{
}
void
Trackball::mouseExited(MouseEvent*)
{
}

