#include "ogreapplication.h"
#include <OgreErrorDialog.h>

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of MyApplication
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class MyApplication : public OgreApplication
{
public:
  MyApplication();
  virtual void keyClicked(Ogre::KeyEvent* e);
protected:
  virtual void init();
  Ogre::Overlay* mPanelOverlay;
};

using namespace Ogre;
using namespace std;

//************************************************************
// Implementation of MyApplication
//************************************************************
MyApplication::MyApplication()
  : OgreApplication("My Application")
{
}
void
MyApplication::keyClicked(Ogre::KeyEvent* e)
{
  if (e->getKey() == KC_F1)
  {
    if (mPanelOverlay->isVisible())
      mPanelOverlay->hide();
    else
      mPanelOverlay->show();      
    e->consume();
  }
  else OgreApplication::keyClicked(e);
}
void
MyApplication::init()
{
  mSceneManager->setAmbientLight(ColourValue(1,1,1));
      
  Entity *ent1 = mSceneManager->createEntity("Robot1","robot.mesh");
  SceneNode* node1 = mSceneManager->getRootSceneNode()->createChildSceneNode("Robot1Node");
  node1->attachObject(ent1);

  mPanelOverlay = OverlayManager::getSingleton().getByName("Tutorial2/PanelOverlay");
  mPanelOverlay->show();
}

int main(int, char **)
{
  MyApplication application;
  try
  {
    application.addResourceLocationFrom("../../resources.cfg");
    application.addResourceLocationFrom("./resources.cfg");
    application.create("../../plugins.cfg","../ogre.cfg","ogre.log",ST_GENERIC);
    application.run();
  }
  catch (Exception& e)
  {
    ErrorDialog* dlg = PlatformManager::getSingleton().createErrorDialog();
    dlg->display(e.getFullDescription());
    delete dlg;
    return 1;
  }
  return 0;
}

