#include "ogreapplication.h"
#include <OgreErrorDialog.h>

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of MyApplication
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class MyApplication : public OgreApplication
{
public:
  MyApplication();
protected:
  virtual void init();
private:
};

using namespace Ogre;
using namespace std;

//************************************************************
// Implementation of MyApplication
//************************************************************
MyApplication::MyApplication()
  : OgreApplication("My Application")
{
}
void
MyApplication::init()
{
  mSceneManager->setAmbientLight(ColourValue(1,1,1));
      
  Entity *ent1 = mSceneManager->createEntity("Robot1","robot.mesh");
  SceneNode* node1 = mSceneManager->getRootSceneNode()->createChildSceneNode("Robot1Node");
  node1->attachObject(ent1);

  Entity *ent2 = mSceneManager->createEntity("Ninja1","ninja.mesh");
  SceneNode* node2 = mSceneManager->getRootSceneNode()->createChildSceneNode("Ninja1Node");
  node2->attachObject(ent2);
  node2->setPosition(Vector3(50,0,0));
  node2->setScale(Vector3(0.42f,0.42f,0.42f));  
}
int main(int, char **)
{
  MyApplication application;
  try
  {
    application.addResourceLocationFrom("../../resources.cfg");
    application.create("../../plugins.cfg","../ogre.cfg","ogre.log",ST_GENERIC);
    application.run();
  }
  catch (Exception& e)
  {
    ErrorDialog* dlg = PlatformManager::getSingleton().createErrorDialog();
    dlg->display(e.getFullDescription());
    delete dlg;
    return 1;
  }
  return 0;
}

